# Generated by ariadne-codegen
# Source: runpod.schema

from typing import Any, List, Optional

from pydantic import Field

from .base_model import BaseModel
from .enums import (
    BillingGranularity,
    CloudTypeEnum,
    Compliance,
    ComputeType,
    EndpointStatisticGranularity,
    UserServerlessBillingGroupBy,
)


class EarningsCustomRangeInput(BaseModel):
    start_date: Any = Field(alias="startDate")
    end_date: Any = Field(alias="endDate")


class EnvironmentVariableInput(BaseModel):
    key: str
    value: str


class GpuAvailabilityInput(BaseModel):
    gpu_count: Optional[int] = Field(alias="gpuCount", default=None)
    min_disk: Optional[int] = Field(alias="minDisk", default=None)
    min_memory_in_gb: Optional[int] = Field(alias="minMemoryInGb", default=None)
    min_vcpu_count: Optional[int] = Field(alias="minVcpuCount", default=None)
    secure_cloud: Optional[bool] = Field(alias="secureCloud", default=None)
    allowed_cuda_versions: Optional[List[Optional[str]]] = Field(
        alias="allowedCudaVersions", default=None
    )
    include_ai_api: Optional[bool] = Field(alias="includeAiApi", default=None)


class GpuLowestPriceInput(BaseModel):
    country_code: Optional[str] = Field(alias="countryCode", default=None)
    data_center_id: Optional[str] = Field(alias="dataCenterId", default=None)
    gpu_count: int = Field(alias="gpuCount")
    include_ai_api: Optional[bool] = Field(alias="includeAiApi", default=None)
    min_disk: Optional[int] = Field(alias="minDisk", default=None)
    min_download: Optional[int] = Field(alias="minDownload", default=None)
    min_memory_in_gb: Optional[int] = Field(alias="minMemoryInGb", default=None)
    min_upload: Optional[int] = Field(alias="minUpload", default=None)
    min_vcpu_count: Optional[int] = Field(alias="minVcpuCount", default=None)
    secure_cloud: Optional[bool] = Field(alias="secureCloud", default=None)
    support_public_ip: Optional[bool] = Field(alias="supportPublicIp", default=None)
    total_disk: Optional[int] = Field(alias="totalDisk", default=None)
    cuda_version: Optional[str] = Field(alias="cudaVersion", default=None)
    allowed_cuda_versions: Optional[List[Optional[str]]] = Field(
        alias="allowedCudaVersions", default=None
    )
    compliance: Optional[List[Optional[Compliance]]] = None


class GpuTypeFilter(BaseModel):
    id: Optional[str] = None
    ids: Optional[List[str]] = None


class NetworkStorageEarningInput(BaseModel):
    granularity: Optional[str] = None


class PodBidResumeInput(BaseModel):
    pod_id: str = Field(alias="podId")
    gpu_count: int = Field(alias="gpuCount")
    bid_per_gpu: float = Field(alias="bidPerGpu")


class PodEditJobInput(BaseModel):
    pod_id: str = Field(alias="podId")
    docker_args: Optional[str] = Field(alias="dockerArgs", default=None)
    image_name: str = Field(alias="imageName")
    env: Optional[List[Optional["EnvironmentVariableInput"]]] = None
    port: Optional[Any] = None
    ports: Optional[str] = None
    container_disk_in_gb: int = Field(alias="containerDiskInGb")
    volume_in_gb: Optional[int] = Field(alias="volumeInGb", default=None)
    volume_mount_path: Optional[str] = Field(alias="volumeMountPath", default=None)
    container_registry_auth_id: Optional[str] = Field(
        alias="containerRegistryAuthId", default=None
    )


class PodFilter(BaseModel):
    pod_id: str = Field(alias="podId")


class PodFindAndDeployOnDemandInput(BaseModel):
    ai_api_id: Optional[str] = Field(alias="aiApiId", default=None)
    cloud_type: Optional[CloudTypeEnum] = Field(alias="cloudType", default=None)
    container_disk_in_gb: Optional[int] = Field(alias="containerDiskInGb", default=None)
    country_code: Optional[str] = Field(alias="countryCode", default=None)
    deploy_cost: Optional[float] = Field(alias="deployCost", default=None)
    docker_args: Optional[str] = Field(alias="dockerArgs", default=None)
    env: Optional[List[Optional["EnvironmentVariableInput"]]] = None
    gpu_count: Optional[int] = Field(alias="gpuCount", default=None)
    gpu_type_id: Optional[str] = Field(alias="gpuTypeId", default=None)
    gpu_type_id_list: Optional[List[Optional[str]]] = Field(
        alias="gpuTypeIdList", default=None
    )
    image_name: Optional[str] = Field(alias="imageName", default=None)
    min_disk: Optional[int] = Field(alias="minDisk", default=None)
    min_download: Optional[int] = Field(alias="minDownload", default=None)
    min_memory_in_gb: Optional[int] = Field(alias="minMemoryInGb", default=None)
    min_upload: Optional[int] = Field(alias="minUpload", default=None)
    min_vcpu_count: Optional[int] = Field(alias="minVcpuCount", default=None)
    name: Optional[str] = None
    network_volume_id: Optional[str] = Field(alias="networkVolumeId", default=None)
    port: Optional[Any] = None
    ports: Optional[str] = None
    start_jupyter: Optional[bool] = Field(alias="startJupyter", default=None)
    start_ssh: Optional[bool] = Field(alias="startSsh", default=None)
    stop_after: Optional[Any] = Field(alias="stopAfter", default=None)
    support_public_ip: Optional[bool] = Field(alias="supportPublicIp", default=None)
    template_id: Optional[str] = Field(alias="templateId", default=None)
    terminate_after: Optional[Any] = Field(alias="terminateAfter", default=None)
    volume_in_gb: Optional[int] = Field(alias="volumeInGb", default=None)
    volume_key: Optional[str] = Field(alias="volumeKey", default=None)
    volume_mount_path: Optional[str] = Field(alias="volumeMountPath", default=None)
    data_center_id: Optional[str] = Field(alias="dataCenterId", default=None)
    savings_plan: Optional["SavingsPlanInput"] = Field(
        alias="savingsPlan", default=None
    )
    cuda_version: Optional[str] = Field(alias="cudaVersion", default=None)
    allowed_cuda_versions: Optional[List[Optional[str]]] = Field(
        alias="allowedCudaVersions", default=None
    )
    instance_ids: Optional[List[Optional[str]]] = Field(
        alias="instanceIds", default=None
    )
    compute_type: Optional[ComputeType] = Field(alias="computeType", default=None)


class PodRentInterruptableInput(BaseModel):
    bid_per_gpu: Optional[float] = Field(alias="bidPerGpu", default=None)
    cloud_type: Optional[CloudTypeEnum] = Field(alias="cloudType", default=None)
    container_disk_in_gb: Optional[int] = Field(alias="containerDiskInGb", default=None)
    country_code: Optional[str] = Field(alias="countryCode", default=None)
    docker_args: Optional[str] = Field(alias="dockerArgs", default=None)
    env: Optional[List[Optional["EnvironmentVariableInput"]]] = None
    gpu_count: Optional[int] = Field(alias="gpuCount", default=None)
    gpu_type_id: Optional[str] = Field(alias="gpuTypeId", default=None)
    image_name: Optional[str] = Field(alias="imageName", default=None)
    min_disk: Optional[int] = Field(alias="minDisk", default=None)
    min_download: Optional[int] = Field(alias="minDownload", default=None)
    min_memory_in_gb: Optional[int] = Field(alias="minMemoryInGb", default=None)
    min_upload: Optional[int] = Field(alias="minUpload", default=None)
    min_vcpu_count: Optional[int] = Field(alias="minVcpuCount", default=None)
    name: Optional[str] = None
    network_volume_id: Optional[str] = Field(alias="networkVolumeId", default=None)
    port: Optional[Any] = None
    ports: Optional[str] = None
    start_jupyter: Optional[bool] = Field(alias="startJupyter", default=None)
    start_ssh: Optional[bool] = Field(alias="startSsh", default=None)
    stop_after: Optional[str] = Field(alias="stopAfter", default=None)
    support_public_ip: Optional[bool] = Field(alias="supportPublicIp", default=None)
    template_id: Optional[str] = Field(alias="templateId", default=None)
    terminate_after: Optional[str] = Field(alias="terminateAfter", default=None)
    volume_in_gb: Optional[int] = Field(alias="volumeInGb", default=None)
    volume_key: Optional[str] = Field(alias="volumeKey", default=None)
    volume_mount_path: Optional[str] = Field(alias="volumeMountPath", default=None)
    data_center_id: Optional[str] = Field(alias="dataCenterId", default=None)
    cuda_version: Optional[str] = Field(alias="cudaVersion", default=None)
    allowed_cuda_versions: Optional[List[Optional[str]]] = Field(
        alias="allowedCudaVersions", default=None
    )


class PodResumeInput(BaseModel):
    pod_id: str = Field(alias="podId")
    gpu_count: Optional[int] = Field(alias="gpuCount", default=None)
    sync_machine: Optional[bool] = Field(alias="syncMachine", default=None)
    compute_type: Optional[ComputeType] = Field(alias="computeType", default=None)


class PodStopInput(BaseModel):
    pod_id: str = Field(alias="podId")
    increment_version: Optional[bool] = Field(alias="incrementVersion", default=None)


class PodTerminateInput(BaseModel):
    pod_id: str = Field(alias="podId")


class SaveRegistryAuthInput(BaseModel):
    name: str
    username: str
    password: str


class SavingsPlanInput(BaseModel):
    plan_length: Optional[str] = Field(alias="planLength", default=None)
    upfront_cost: Optional[float] = Field(alias="upfrontCost", default=None)


class SpecificsInput(BaseModel):
    instance_id: Optional[str] = Field(alias="instanceId", default=None)
    data_center_id: Optional[str] = Field(alias="dataCenterId", default=None)


class UserBillingInput(BaseModel):
    granularity: Optional[BillingGranularity] = None


class UserMachinesFilter(BaseModel):
    start: Optional[int] = None
    end: Optional[int] = None


class UserServerlessBillingInput(BaseModel):
    group_by: Optional[UserServerlessBillingGroupBy] = Field(
        alias="groupBy", default=None
    )


class WebhookRequestsInput(BaseModel):
    granularity: Optional[EndpointStatisticGranularity] = None


class WorkerStateInput(BaseModel):
    granularity: Optional[EndpointStatisticGranularity] = None


class backgroundPodTelemetryInput(BaseModel):
    machine_id: Optional[str] = Field(alias="machineId", default=None)
    gpu_index: Optional[int] = Field(alias="gpuIndex", default=None)


PodEditJobInput.model_rebuild()
PodFindAndDeployOnDemandInput.model_rebuild()
PodRentInterruptableInput.model_rebuild()
